/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/time.h>
#ifdef __linux__
#include <linux/vt.h>
#endif
#include <string.h>
#include <ggi/libggi.h>
#include "ggi_screensaver.h"

#include <structs.h>

/* register screensavers */
void reg_savers();
void done_savers();
void ge_crazy(ggi_visual_t visual);

/*
 * This structure contains all screensavers in this module:
 */
ggi_saver_list saver_list[] = {
	{ ge_crazy, "Crazy Lines"},
};

/*
 * register all screen-savers in the main module
 */
void reg_savers()
{
	int i;
	for (i=0; i<(sizeof(saver_list)/sizeof(ggi_saver_list)); i++) {
		install_saver(saver_list[i].func, saver_list[i].name);
	}
}

/*
 * free resources allocated by the screen-savers
 */
void done_savers()
{
}  

void ge_crazy(ggi_visual_t visual)
{ int x,y;
	ggi_mode mode;
	int xsize, ysize;
	ggiGetMode(visual,&mode);
	xsize=mode.visible.x;
	ysize=mode.visible.y;

  for(x=-(ysize-1);;)
  { if (switchaway||ggiKbhit(visual)) break;

    y=x;if (y<0) y=-y;

    ggiSetGCForeground(visual,1);
    ggiDrawHLine(visual,0,y,xsize/2);

    ggiSetGCForeground(visual,128);
    ggiDrawHLine(visual,xsize/2,ysize-1-y,xsize/2);

    if ((x&15)==0) usleep(1);
    ggiSetGCForeground(visual,0);
    ggiDrawHLine(visual,0,y,xsize/2);
    ggiDrawHLine(visual,xsize/2,ysize-1-y,xsize/2);

    if (++x>ysize-1) x=-(ysize-1);
  }
}
